<template>
  <div class="login">
    <div class="title-wrapper d-flex align-items-center">
      {{ $t('auth.login.title') }}
    </div>

    <div class="content-wrapper">
      <div class="upper-wrapper">
        <div class="title text-center">
          {{ $t('auth.login.note') }}
        </div>
        <div class="link d-flex justify-content-center align-items-center">
          <a class="iconmo-lock" href="https://dashboard.heta.org"></a>
          <a class="text" href="https://dashboard.heta.org">https://dashboard.heta.org</a>
        </div>
      </div>

      <div class="main-wrapper">

        <div class="input-wrapper">
          <div class="input_group username-wrapper d-flex align-items-center">
            <div class="input_group_prepend">
              <span class="input-group-text"><i class="iconmo-email"></i></span>
            </div>
            <input class="input-username form-control w-100" data-vv-validate-on="none" @keyup.enter="login"
                   v-validate="'required|email'" @focus="resetError" v-model="email" type="email" :placeholder="$t('auth.placeholder.email')"
                   name="email">
            <span class="invalid-feedback" v-if="errors.has('email')">
              {{ errors.first('email') }}
              <a href="javascript:void(0)" style="text-decoration: underline"
                 v-if="errors.count() === 1 && errors.first('email') === $t('validation.email_verify', {attribute: 'email'})"
                 @click="sendVerifyUser"> {{$t('sign.resend')}} </a>
            </span>
          </div>

          <div class="input_group password-wrapper d-flex align-items-center">
            <div class="input_group_prepend">
              <span class="input-group-text"><i class="iconmo-password"></i></span></div>
            <input class="input-password form-control w-100" data-vv-validate-on="none" @keyup.enter="login"
                   v-validate="'required'" @focus="resetError" v-model="password" :placeholder="$t('auth.placeholder.password')" name="password"
                   type="password">
            <span class="invalid-feedback" v-if="errors.has('password')">{{ errors.first('password') }}</span>
          </div>
        </div>

        <div class="submit-btn text-center">
          <button type="button" class="button-primary" @click="login">{{ $t('auth.btn.upper_login') }}</button>
        </div>

        <div class="below-wrapper text-center">
          <div class="forgot">
            <a href="javascript:void(0)" class="text-link" @click="$router.push('/reset-password')">{{ $t('auth.login.forgot_password') }}</a>
          </div>
          <div class="register">
            <span>{{ $t('auth.login.not_have_account') }} <a class="text" @click="gotoRegisterPage()">{{ $t('auth.btn.register') }}</a></span>
          </div>
        </div>
      </div>

    </div>
  </div>
</template>

<script>
  import rf from '../../../common/requests/RequestFactory';
  import CheckAuthMixin from './CheckAuthMixin';
  import ModalMixin from '../../../common/components/ModalMixin';
  import OtpConfirmModal from '../../components/Modal/OtpConfirmModal.vue';

  export default {
    data () {
      return {
        email: '',
        password: '',
      };
    },
    mixins: [CheckAuthMixin, ModalMixin],
    methods: {
      sendVerifyUser() {
        if (this.email) {
          rf.getRequest('UserRequest').sendVerifyUser({email: this.email}).then(() => {
            this.$toasted.show(this.$t('sign.resend_successful'), {
              theme: 'bubble',
              position: 'top-right',
              duration: 2000
            });
          });
        }
      },
      resetError () {
        if (this.errors.any()) {
          this.errors.clear();
        }
      },
      gotoRegisterPage () {
        this.$router.push('/register');
      },
      login () {
        this.$validator.validateAll().then(() => {
          if (this.errors.any()) {
            return;
          }
          const params = {
            email: this.email,
            password: this.password
          };
          rf.getRequest('UserRequest')
            .login(params)
            .then(res => {
              window.location.href = '/';
            })
            .catch(error => {
              const errors = error.errors;
              this.initErrors(errors);
              if (this.errors.has('code')) {
                this.errors.clear();
                this.$broadcast('open-modal', OtpConfirmModal, {
                  callback: this.requestLogin,
                  key: `${this._uid}-login`
                });
              }
            });
        });
      },
      initErrors (errors) {
        this.errors.clear();
        Object.keys(errors).forEach(key => {
          this.errors.add({
            field: key,
            msg: errors[key][0],
          });
        });
      },
      requestLogin (params) {
        return rf.getRequest('UserRequest').login(
          Object.assign({
              email: this.email,
              password: this.password,
            },
            params
          )
        );
      }
    },
    created () {
      this.$on(`${this._uid}-login-callback-has-errors`, errors => {
        this.initErrors(errors);
      });
      this.$on(`${this._uid}-login-confirm-otp-successful`, () => {
        window.location.href = '/';
      });
    }
  };
</script>

<style lang="scss" scoped>
  @import "../../../../sass/mobile/typoVariables";

  .login {
    height: calc(100vh - 168rem);
    min-height: 440rem;
    background: $bg_primary;
    font-size: $medium;
    .title-wrapper {
      padding-left: 13rem;
      background-color: #21335b;
      height: 55rem;
      line-height: initial;
      font-size: 18rem;
      color: $white;
    }
    .content-wrapper {
      padding: 37rem $tiny 68rem $tiny;
      .upper-wrapper {
        .title {
          @extend .Medium-14;
          color: #989898;
        }
        .link {
          margin-top: 7rem;
          height: 33px;
          border-radius: 16.5rem;
          background-color: #f0f0f0;
          border: solid 1rem #d8d8d8;
          .iconmo-QRcode:before {
            font-size: 15rem;
            margin-right: 5rem;
          }
          .text {
            @extend .bold-14;
            line-height: 3.57;
            color: #fa7300;
            text-decoration: underline;
          }
        }
      }
      .register {
        .text {
          text-transform: capitalize;
        }
      }
      .main-wrapper {
        margin-top: 37rem;
        input:-webkit-autofill,
        input:-webkit-autofill:hover,
        input:-webkit-autofill:focus textarea:-webkit-autofill,
        select:-webkit-autofill,
        select:-webkit-autofill:hover,
        select:-webkit-autofill:focus {
          border: none;
          -webkit-text-fill-color: #000;
          -webkit-box-shadow: 0 0 0px 1000px $white inset;
        }
        .invalid-feedback {
          font-size: 13rem;
          color: red;
          display: block;
          padding-left: $tiny;
        }
        .input-wrapper {
          .username-wrapper {
            position: relative;
            height: 40rem;
            border-radius: 74rem;
            background-color: $white;
            outline: none;
            .icon-user:before {
              font-size: 15rem;
              padding: 0 5rem 0 10rem;
              color: #d8d8d8;
            }
            .input-username {
              @extend .Medium-14;
              border: 1px solid transparent;
              color: #000;
              &::placeholder {
                color: #cacaca;
              }
            }
          }
          .password-wrapper {
            position: relative;
            height: 40rem;
            border-radius: 74rem;
            outline: none;
            background-color: $white;
            margin-top: 20rem;
            .icon-lock:before {
              font-size: 15rem;
              padding: 0 5rem 0 10rem;
              color: #d8d8d8;
            }
            .input-password {
              @extend .Medium-14;
              border: 1px solid transparent;
              color: #000;
              &::placeholder {
                color: #cacaca;
              }
            }
          }
          .form-control {
            outline: none;
          }
        }
        .submit-btn {
          margin-top: 25rem;
          button {
            @extend .button-12;
            background: transparent;
            width: 100rem !important;
            height: 32rem !important;
            border-radius: 30rem !important;
            border: solid 1rem #fa7300;
            color: #fa7300;
            font-weight: bold;
            letter-spacing: 0.5rem;
            outline: none;
          }
        }
      }
      .below-wrapper {
        margin-top: 20rem;
        @extend .Medium-14;
        .forgot a {
          color: #989898;
          text-decoration: underline;
        }
        .register {
          color: #989898;
          margin-top: 8rem;
          .text {
            font-size: $tiny;
            font-weight: bold;
            line-height: 2.5;
            letter-spacing: 0.5px;
            color: #fa7300;
          }
        }
      }
    }
    .invalid-feedback {
      color: red;
      position: absolute;
      text-align: left;
      bottom: -20rem;
      font-size: 10rem;
      left: 5rem;
    }
  }

  .input_group {
    background-color: #f0f0f0;
    input {
      border: 1px solid transparent;
      color: #000;
      padding-left: 40rem;
      height: 100%;
      border-radius: 74rem;
      outline: none;
      &:focus {
        box-shadow: 0 0 20px 0 rgba(0, 0, 0, 0.15);
      }
    }
    .input_group_prepend {
      width: 19px;
      display: inline-block;
      margin-left: 16rem;
      line-height: 45rem;
      font-size: 15.5rem;
      position: absolute;
      color: #B0B0B0;
    }
  }

  .button-primary {
    width: 122rem !important;
    height: 35rem !important;
    border-radius: 30rem !important;
    background-color: #fa7300 !important;

    border: none !important;
    outline: none !important;
    color: white !important;
    cursor: pointer !important;
    letter-spacing: 1rem !important;
    font-weight: bold !important;
  }

  .text-link {
    color: #fa7300 !important;
    cursor: pointer !important;
    &:hover {
      text-decoration: underline;
    }
  }
  .iconmo-lock {
    position: relative;
    top: -1rem;
    color: #fa7300;
  }
</style>
